#include <stdio.h>      // Entrada/Sada padro
#include <stdlib.h>     // Biblioteca padro
#include <string.h>     // Funes string
#include <errno.h>
#ifdef __WIN32__
 #include <windows.h>
 #include <winsock.h>
 #include <fcntl.h>
 #include <io.h>
#else
 #include <sys/types.h>
 #include <arpa/inet.h>  // Funes para manipular endereos Internet (inter-redes)
 #include <fcntl.h>
 #include <netdb.h>
 #include <netinet/in.h> // Contm a estrutura sockaddr_in
 #include <signal.h>
 #include <sys/socket.h> // Comunicao
 #include <unistd.h>     // read e write
 #include <sys/time.h>
 #include <ulimit.h>
 #include <sys/resource.h>
 #include <sys/vtimes.h>
#endif
#include <time.h>       // Obter data/hora do sistema
#include "def.h"
#include "misc.h"
#include "main.h"
#include "eventos.h"
#include "usuario.h"

#define CORE         // Para gerar arquivos core
//#define DEBUG        // Para no colocar o programa em segundo plano
//#define MOSTRAOBJ    // Para mostrar tamanho dos objetos

char arqnome[200];
char * arqext;

//------------------------------------------------------------------------------
#if defined(__BORLANDC__) || defined(__BCPLUSPLUS)
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    int argc=1;
    char * argv[] = { "sevmud.exe", 0 };
#else
int main(int argc, char *argv[])
{
#endif
#ifdef __WIN32__
        // Inicializa WinSock
    WSADATA info;
    bool xinic=(WSAStartup(MAKELONG(1, 1), &info) != SOCKET_ERROR);
    if (!xinic)
        exit(EXIT_FAILURE);
#endif
// Variveis
    char mens[300];
    int  lido;
    int  conManip;
    char *p=0;
    int  porta;
    unsigned short porta2;
    FILE * log;

    tabASCinic();               // Prepara tabela ASCII

// Gerar arquivos core
#if defined CORE && !defined __WIN32__
    {
        struct rlimit l;
        l.rlim_cur = 1000000;
        l.rlim_max = 1000000;
        if (setrlimit(RLIMIT_CORE, &l)<0)
        {
            perror("ULIMIT");
            exit(EXIT_FAILURE);
        }
        // Muda prioridade, para programa executar o mais
        // lento possvel
        //setpriority(PRIO_PROCESS, (int)getpid(), PRIO_MAX);
    }
#endif

// Verifica parmetros
    copiastr(mens, argv[0], sizeof(mens));
    for (p=argv[0]; *p; p++)
        if (*p=='/' || *p=='\\')
            copiastr(mens, p+1, sizeof(mens));
    for (p=mens; *p; p++)
        if (*p=='.')
            *p=0;
    copiastr(arqnome, mens, sizeof(arqnome)-15);
    for (arqext=arqnome; *arqext; arqext++);

// Prepara o mapa
#ifdef __WIN32__
    strcpy(arqext, ".log");
    log=fopen(arqnome, "w");
    if (log==0)
        Terminar(EXIT_FAILURE);
#else
    log=stdout;
#endif

// Mostra tamanho dos objetos
#ifdef MOSTRAOBJ
    fprintf(log, "TObjeto=%d  TJogador=%d  TRegistro=%d\n",
            sizeof(TObjeto), sizeof(TJogador), sizeof(TRegistro));
    fflush(log);
#endif

// L arquivo de configurao
    strcpy(arqext, ".cfg");
    conManip=open(arqnome, O_RDONLY);
    if (conManip<0)
    {
        fprintf(log, "Abrindo arquivo %s: %s\n",
                arqnome, strerror(errno));
        Terminar(EXIT_FAILURE);
    }
    lido=read(conManip, mens, sizeof(mens)-1);
    mens[lido]=0;
    close(conManip);
    for (p=mens; *p==' '; p++);
    porta = atoi(p);
    if (porta<=1024 || porta>65535)
    {
        fprintf(log, "Porta deve ser um nmero de 1024 a 65535: %s\n", mens);
        Terminar(EXIT_FAILURE);
    }

// Cria objeto para esperar conexo
    TServMud * ServMud;
    if ((ServMud=new TServMud)==0)
    {
        perror("Alocando memria");
        Terminar(EXIT_FAILURE);
    }
    porta2=porta;
    p=ServMud->sAtivar(&porta2);
    if (p)
    {
        puts(p);
        Terminar(EXIT_FAILURE);
    }

// Fecha arquivo de log
    fprintf(log, "Feito...\n");
#ifdef __WIN32__
    fclose(log);
#endif
    srand(time(0));             // Para gerar nmeros aleatrios

// Coloca o programa em segundo plano
#if !defined DEBUG && !defined __WIN32__
    {
        fflush(stdout);
        switch (fork())
        {
        case -1:
            perror("Erro em fork()");
            exit(EXIT_FAILURE);
        case 0:
            // Processo "filho" retorna com _exit(0)
            break;
        default:
            exit(EXIT_SUCCESS);
        }
        setsid();
        switch (fork())
        {
        case -1:
            exit(EXIT_FAILURE);
        case 0:
            break;
        default:
            exit(EXIT_SUCCESS);
        }
        int arq=open("/dev/null",O_RDWR);
        dup2(arq,STDIN_FILENO);
        dup2(arq,STDOUT_FILENO);
        dup2(arq,STDERR_FILENO);
        close(arq);
    }
#endif

// Processamento de eventos
    ProcessarIni();

// Fim - nunca dever chegar at aqui
    Terminar(EXIT_SUCCESS);
    return 0;
}
