#ifndef MISC_H
#define MISC_H

#define TAM_NOME 16

        // Para transformao de caracteres
        // tabASCinic deve ser chamado no incio do programa
extern char tabASC[];
extern char tabCOMPLETO[256];
void tabASCinic(void);

        // Monta string
        // Usar no lugar de snprintf(), que no est presente em alguns UNIXes
char * mprintf(char * destino, int tamanho, const char * mens, ...);

        // Semelhante a strcpy(), mas retorna endereo do byte =0 em destino
char * copiastr(char * destino, const char * origem);

        // Semelhante a strcpy(), mas retorna endereo do byte =0 em destino
        // tamanho = nmero de caracteres que pode escrever em destino
        // tamanho-1 = nmero de caraceres que origem deve ter,
        //             se origem no for uma string em ASCIIZ
char * copiastr(char * destino, const char * origem, int tamanho);

        // Compara duas strings terminadas em espao ou 0
        // Retorna: 0=strings iguais  -1=string1<string2  1=string1>string2
int compara(const char * string1, const char * string2);

        // Compara duas strings ASCIIZ
        // Retorna: 0=strings iguais  -1=string1<string2  1=string1>string2
int comparaZ(const char * string1, const char * string2);

        // Verifica se nome vlido, mas no verifica se  um comando do chat
        // Entrada: nome em ASCIIZ (termina com 0 ou ' ')
        // Retorna: 0=nome invlido para sala e usurio
        //          1=nome vlido s para sala
        //          2=nome vlido para sala e usurio
char verifNome(const char * nome1);

        // Prepara mensagem para ser enviada para Telnet
        // Retorna tamanho da mensagem (quandos bytes enviar via cEnvia())
int PreparaTelnet(char * destino, const char * origem, int tamdestino);

        // Prepara mensagem para ser enviada para Papovox
        // tamlinha = quantos caracteres por linha o Papovox suporta, geralmente 80 ou 256
        // Retorna tamanho da mensagem (quandos bytes enviar via cEnvia())
int PreparaPapovox(char * destino, const char * origem, int tamdestino, int tamlinha);

#endif
