#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#ifdef __WIN32__
 #include <windows.h>
 #include <winsock.h>
 #include <fcntl.h>
 #include <io.h>
 #define close closesocket
#else
 #include <sys/types.h>
 #include <arpa/inet.h>  // Funes para manipular endereos Internet (inter-redes)
 #include <fcntl.h>
 #include <netdb.h>
 #include <netinet/in.h> // Contm a estrutura sockaddr_in
 #include <signal.h>
 #include <sys/socket.h> // Comunicao
 #include <unistd.h>     // read e write
 #include <sys/time.h>
#endif
#include "def.h"
#include "misc.h"
#include "usuario.h"
#include "eventos.h"
#include "main.h"

#define CRLF "\x0D\x0A"

// Tempo (1-300 segundos) para enviar mensagens
// pedindo apelido/senha e mensagens vazias
#define TEMPO_ENTRANDO (60*5)
#define TEMPO_VAZIO (300*5)   // Mensagens para telnet/papovox/bot

// Tamanho mximo das mensagens recebidas e enviadas para o chat
// Deve ser um nmero de 80 a 1000
#define BUF_MENS 300

//------------------------------------------------------------------------------
TUsuario * TUsuario::Primeiro=0;
TUsuario * TUsuario::Ultimo=0;
static bool con1=false;
static struct in_addr con2;
static TClienteMud * ClienteMud=0;

//------------------------------------------------------------------------------
// Nova conexo
void TServMud::sEvento(short EvSock, struct sockaddr_in * localSockStr)
{
    const char * p = inet_ntoa(localSockStr->sin_addr);
    char mens[100];
    copiastr(mens, p, sizeof(mens));
    p = inet_ntoa(con2);
    bool b = (con1 && strcmp(p, mens)==0);
    if (strcmp(mens, "127.0.0.1")!=0 && !b)
    {
//printf("Acesso negado: [%s] [%s]\n", p, mens);
        p = "-Acesso negado" CRLF;
        send(EvSock, p, strlen(p), 0);
        close(EvSock);
        return;
    }
    if (b)
        con1=false;

// Cria novo objeto
    TUsuario * endObj=new TUsuario;
// Recusa conexo
    if (endObj==0)
        close(EvSock);
// Aceita conexo
    else
    {
        endObj->cSockEnv = EvSock;
        endObj->cSockRec = endObj->cSockEnv;// Receber dados do cliente
        endObj->rTempo(10*5); // Chamar evento em 10 segundos
                // Mensagem inicial
        endObj->cEnvia("+OK Para telnet pressione ENTER"  CRLF);
    }
}

//------------------------------------------------------------------------------
TClienteMud::TClienteMud()
{
    pontRec=0;
    dadoRecebido=0;
    pontTelnet=0;
}

//------------------------------------------------------------------------------
void TClienteMud::EnvMens(const char * endMens)
{
    char mens[COMUNICA_BUF-100];
    mprintf(mens, sizeof(mens), "%s" CRLF, endMens);
    cEnvia(mens);
}

//------------------------------------------------------------------------------

//Recebe: 255(IAC)  251(WILL)  x
//Envia:  255(IAC)  253(DO)    x

//Recebe: 255(IAC)  253(DO)    x
//Envia:  255(IAC)  251(WILL)  x

//Recebe: 255(IAC)  250(SB)  x  ...  255(IAC) 240(SE)
//???

//Recebe  255 x y -> Ignora

void TClienteMud::cEvento(const char * buffer, int tamanho)
{
// Processa: Conexo terminou ou buffer de envio est vazio
// Para processar uma pgina, fazer Pagina=nmero da pgina e chamar cEvento(0,1)
    if (buffer==0)
    {
        if (tamanho==0) // Conexo terminada: apaga objeto
        {
            TUsuario::EnvTodos("/Conexo com o MUD terminada");
            ClienteMud=0;
            delete this;
        }
        return;
    }
    rTempo(3);
// Envia para quem quer receber a mensagem como chegou
    //for (TUsuario * u = TUsuario::Primeiro; u; u=u->Depois)
    //    if (u->Proto>2)
    //        u->cEnvia(buffer, tamanho);
// Interpretar mensagem recebida
    while (tamanho>0)
    {
        bool sair=true;
        char dado;
        if (pontRec<3)
            pontRec=3;
        while (tamanho)
        {
        // Obtm prximo caracter
            dado=*buffer++;
            tamanho--;
 //printf("[%d;%d] ",dado,dadoRecebido); fflush(stdout);//------- Para mostrar o que chegou
 //printf(" %d ", (unsigned char)dado);
 //if ((unsigned char)dado>=32) { putchar(dado); fflush(stdout); }
        // Protocolo do Telnet

        // Primeiro caracter  - IAC
            if (pontTelnet==0)
            {
                if (dado==0)
                    continue;
                if (dado==(char)255)
                {
                    bufTelnet[pontTelnet++]=dado;
                    continue;
                }
            }
        // Mensagem comprida (SB + SE)
        // 255 250 ... 255 240 = mensagem
            if (pontTelnet>=3)
                if (bufTelnet[pontTelnet-1]==(char)255 && dado==(char)240)
                {
                    if (bufTelnet[2]==24 && bufTelnet[3]==1) // Quer saber o terminal
                    {
                        cEnvia("\xFF\xFA\x18\x00" // Comando
                               "TERM" // Nome
                               "\xFF\xF0", 10); // Fim do comando
                    }
                    pontTelnet=0;
                    continue;
                }
        // Anota caracter no buffer
            if (pontTelnet>=(int)sizeof(bufTelnet))
                pontTelnet--;
            if (pontTelnet)
                bufTelnet[pontTelnet++]=dado;
        // Mensagem de 2 bytes
        // 255 255 = caracter 255
        // 255 240 = mensagem 240
            if (pontTelnet==2)
            {
                if (dado==(char)255 || dado==(char)240)
                    pontTelnet=0;
                continue;
            }
        // Mensagem de 3 bytes
        // 255 x y = mensagem x y
            if (pontTelnet==3 && bufTelnet[1]!=(char)250)
            {
                if (bufTelnet[1]==(char)251 || bufTelnet[1]==(char)253)
                {
                    bufTelnet[1]^=6;
                    switch (bufTelnet[2])
                    {
                    case 1:
                    case 3:
                    case 5:
                    case 6:
                    case 24:
                    case 31:
                    case 32:
                    case 33:
                    case 34:
                    case 36:
                        break;
                    default: bufTelnet[1]++;
                    }
                    cEnvia(bufTelnet, 3);
                }
                if (bufTelnet[2]==31) // Quer saber o tamanho da janela
                    cEnvia("\xFF\xFA\x1F" // Comando
                           "\x00\x50\x00\x19" // Tamanho
                           "\xFF\xF0", 9); // Fim do comando
                pontTelnet=0;
                continue;
            }
            if (pontTelnet)
                continue;
        // Ignorar caracteres
            if (dadoRecebido==2)
                if (dado>' ' && ((dado|0x20)<'a' || (dado|0x20)>'z'))
                {
                    if (pontESC<sizeof(bufESC)-2)
                        bufESC[pontESC++]=dado;
                    continue;
                }
                else if (dado>' ')
                {
                    dadoRecebido=0;
                    bufESC[pontESC++]=dado;
                    if (pontRec+pontESC < BUF_MENS+6)
                    {
                        bufRec[pontRec++]=27;
                        memcpy(bufRec+pontRec, bufESC, pontESC);
                        pontRec+=pontESC;
                    }
                    continue;
                }
                else
                    dadoRecebido=0;
 //printf(" CH(%d,%c) ", (unsigned char)dado, (unsigned char)dado>=32?dado:' '); fflush(stdout);
        // Sequncias de controle - caracter ESC
            if (dado==27)
            {
                dadoRecebido=2;
                pontESC=0;
            }
        // Prxima linha
            else if (dado==10 || dado==13)
            {
                if (dado==13 ? dadoRecebido==10 : dadoRecebido==13)
                    dadoRecebido=0;
                else
                {
                    dadoRecebido=dado;
                    if (pontRec>BUF_MENS+4)
                        pontRec=BUF_MENS+4;
                    bufRec[0]=1;
                    bufRec[1]=((pontRec-3) & 0xFF);
                    bufRec[2]=((pontRec-3) >> 8);
                    sair=false;
                    break;
                }
            }
        // BackSpace
            else if (dado==8 || dado==127)
                pontRec-=(pontRec>3);
        // Caracteres imprimveis
            else if (dado)
            {
                if (pontRec<BUF_MENS+5)
                    bufRec[pontRec]=dado;
                pontRec++;
            }
        } // while (tamanho)
        if (sair)
            return;

    // Envia mensagem
        MensMud();
    }
}

//------------------------------------------------------------------------------
void TClienteMud::rEvento()
{
    if (pontRec<=3)
        return;
    bufRec[pontRec<BUF_MENS+3 ? pontRec : BUF_MENS+3]=0;
    for (const char * p=bufRec+3; *p; p++)
    {
        if (*p==' ')
            continue;
        if (*p!=27)
        {
            MensMud();
            return;
        }
        for (p++; *p; p++)
            if (*p==0 || (*p|0x20)>='a' && (*p|0x20)<='z')
                break;
        if (*p==0)
            break;
    }

// Envia mensagem no filtrada
    for (TUsuario * u = TUsuario::Primeiro; u; u=u->Depois)
        if ((u->Opcoes&1) && (u->Proto==1 || u->Proto==2))
            u->cEnvia(bufRec+3);
}

//------------------------------------------------------------------------------
void TClienteMud::MensMud()
{
    if (pontRec<3)
        pontRec=3;

    bufRec[pontRec<BUF_MENS+3 ? pontRec : BUF_MENS+3]=0;
    pontRec=0;

// Envia mensagem no filtrada
    for (TUsuario * u = TUsuario::Primeiro; u; u=u->Depois)
        if ((u->Opcoes&1) && (u->Proto==1 || u->Proto==2))
            u->EnvMens(bufRec+3);

// Filtra mensagem
    char *o,*d;
    for (o=bufRec+3,d=bufRec+3; *o; o++)
    {
        if (*(unsigned char*)o >= ' ')
            *d++=*o;
        if (*o!=27)
            continue;
        for (o++; *o; o++)
            if (*o==0 || (*o|0x20)>='a' && (*o|0x20)<='z')
                break;
        if (*o==0)
            break;
    }
    *d=0;

// Envia mensagem filtrada
    for (TUsuario * u = TUsuario::Primeiro; u; u=u->Depois)
        if ((u->Opcoes&1)==0 && (u->Proto==1 || u->Proto==2))
            u->EnvMens(bufRec+3);
}

//------------------------------------------------------------------------------
TUsuario::TUsuario()
{
    Opcoes=0;
    Passo=0;
    pontRec=0;
    dadoRecebido=0;
    Proto=0;
// Acerta lista encadeada
    Antes = 0;
    Depois = Primeiro;
    Primeiro=this;
    (Depois ? Depois->Antes : Ultimo)=this;
#ifdef DEBUG
    puts("  new TUsuario"); fflush(stdout);
#endif
}

//------------------------------------------------------------------------------
// Apaga objeto, usado internamente
TUsuario::~TUsuario()
{
    (Antes ? Antes->Depois : Primeiro) = Depois;
    (Depois ? Depois->Antes : Ultimo) = Antes;
#ifdef DEBUG
    puts("  delete TUsuario"); fflush(stdout);
#endif
}

//------------------------------------------------------------------------------
bool TUsuario::EnvMens(const char * endMens)
{
    char mens[COMUNICA_BUF-100];
    int total;
 //printf("Mensagem SOCK=%d\n", cSockRec); fflush(stdout);
    if (Proto<2)
        total=PreparaTelnet(mens, endMens, sizeof(mens));
    else
    {
        unsigned int tamlinha=(Opcoes&2 ? 239 : 79);
        total=PreparaPapovox(mens, endMens, sizeof(mens), tamlinha);
    }
    return cEnvia(mens, total);
}

//------------------------------------------------------------------------------
void TUsuario::EnvTodos(const char * mens)
{
    for (TUsuario * u = Primeiro; u; u=u->Depois)
        if (u->Proto)
            u->EnvMens(mens);
}


//------------------------------------------------------------------------------
void TUsuario::EnvInicio()
{
    EnvMens("Digite seu apelido");
}

//------------------------------------------------------------------------------
// Chegou dado ou conexo terminou
void TUsuario::cEvento(const char * buffer, int tamanho)
{
// Processa: Conexo terminou ou buffer de envio est vazio
// Para processar uma pgina, fazer Pagina=nmero da pgina e chamar cEvento(0,1)
    if (buffer==0)
    {
        if (tamanho==0) // Conexo terminada: apaga objeto
            delete this;
        return;
    }
// Mostra o que recebeu (para DEBUG)
#ifdef DEBUG_REC
    printf("Recebeu %d: [\n", cSockRec);
    for (int a=0; a<tamanho; a++)
        putchar(buffer[a]);
    puts("]");
#endif

// Processa: Mensagem recebida
// Nota: tamanho pode tornar-se 0 quando o lao while fechar
    while (tamanho>0)
    {
// Telnet - anota mensagem em bufRec+3
        if (Proto<2)
        {
            bool sair=true;
            char dado;
            if (pontRec<3)
                pontRec=3;
            while (tamanho)
            {
            // Obtm prximo caracter
                dado=*buffer++;
                tamanho--;
     //printf("[%d;%d] ",dado,dadoRecebido); fflush(stdout);//------- Para mostrar o que chegou
            // Ignorar caracteres
                if (dadoRecebido==1 || dadoRecebido==2)
                    dadoRecebido--;
            // Caracter aps IAC
                else if (dadoRecebido==3)
                {
                    dado-=251;
                    dadoRecebido = (dado==(char)255) ? 4 : // IAC SB: ignorar at receber SE
                        ((unsigned char)dado<4) ? 1// IAC DO/DON'T/WILL/WON'T:
                        : 0;        // Outro valor
                }
            // Esperar receber SE
                else if (dadoRecebido==4)
                {
                    if (dado==(char)240)
                        dadoRecebido=0;
                }
            // Interpretar IAC ("Interpret As Command")
                else if (dado==(char)255)
                    dadoRecebido=3;
            // Sequncias de controle - caracter ESC
                else if (dado==27)
                    dadoRecebido=2;
            // Prxima linha
                else if (dado==10 || dado==13)
                {
                    if (dado==13 ? dadoRecebido==10 : dadoRecebido==13)
                        dadoRecebido=0;
                    else
                    {
                        dadoRecebido=dado;
                        if (pontRec>BUF_MENS+4)
                            pontRec=BUF_MENS+4;
                        bufRec[0]=1;
                        bufRec[1]=((pontRec-3) & 0xFF);
                        bufRec[2]=((pontRec-3) >> 8);
                        sair=false;
                        break;
                    }
                }
            // BackSpace
                else if (dado==8 || dado==127)
                    pontRec-=(pontRec>3);
            // Caracteres imprimveis
                else if (dado)
                {
                    if (pontRec<BUF_MENS+5)
                        bufRec[pontRec]=dado;
                    else if (pontRec>2048)
                    {
                        delete this;
                        return;
                    }
                    pontRec++;
                }
            } // while (tamanho)
            if (sair)
                return;
        } // if (Proto<2)
// Papovox - anota mensagem em bufRec+3
        else
        {
            int mensagem;      // Tamanho da mensagem
            int processar;     // Nmero de bytes que sero processados
            int copiar;        // Nmero de bytes que sero copiados
            if (dadoRecebido!=0 && tamanho>0)   // Descarta um caracter:
            {                                   // mudou mudou de modo telnet para papovox
                tamanho--;
                buffer++;
                dadoRecebido=0;
            }
            for (; pontRec<3 && tamanho; tamanho--,buffer++) // Cabealho
                bufRec[pontRec++]=*buffer;
            if (tamanho==0)
                return;
            mensagem = 3+(unsigned char)bufRec[1]    // Tamanho da mensagem
                                +((unsigned char)bufRec[2]<<8);
            if (mensagem>1024 || *bufRec!=1)
            {
                delete this;
                return;
            }
            processar=(tamanho<mensagem-pontRec ? tamanho : mensagem-pontRec);
            copiar=(processar<BUF_MENS+5-pontRec ? processar : BUF_MENS+5-pontRec);
            if (copiar>0)
                memcpy(bufRec+pontRec, buffer, copiar);
            if (processar>0)
            {
                tamanho-=processar;
                buffer+=processar;
                pontRec+=processar;
            }
            if (pontRec<mensagem)
                return;
        }
// Acerta mensagem
        bufRec[pontRec<BUF_MENS+3 ? pontRec : BUF_MENS+3]=0;
        pontRec=0;
 //printf(Proto==0 ? "Telnet/Papovox " : Proto==1 ? "Telnet " :
 //       Proto==2 ? "Papovox " : "HTTP ");
 //printf("[%s]\n", bufRec+3); fflush(stdout);

// A partir daqui: processa mensagem
        if (Proto)
            rTempo(Passo==3 ? TEMPO_VAZIO : TEMPO_ENTRANDO);
        switch (Proto)
        {
// Entrada no bate-papo via telnet/papovox
        case 0:
            if (bufRec[3])
            {
                EnvMens("+OK Entrando via Papovox");
                Proto=2;
            }
            else
            {
                EnvMens("-OK Entrando via telnet; "
                        "para sair tecle /sair ou /quit");
                Proto=1;
            }
            Passo=1;
            rTempo(10);
            break;
// Mensagem via telnet/papovox no bate-papo
        case 1:
          {
            char * pont;            // Verifica se mensagem vazia
            for (pont=bufRec+3; *pont==' '; pont++);
            if (Passo==1)
            {
                EnvInicio();
                Passo=2;
            }
            if (*pont==0 && cNivelEnvia()==4)
            {
                const char mens[] = "tecle" CRLF;
                cEnviaPend();
                cMudaNivel(5,4);
                send(cSockEnv, mens, strlen(mens), 0);
                if ((Opcoes&2)==0) // Volta ltimas mensagens
                    cVoltaMens();
                break;
            }
            if (*pont && cNivelEnvia()==5)
            {
                cMudaNivel(4,4);
                cLimpaMens();
            }
          }
        case 2:  // 2=Papovox, mas tambm  usado para Telnet
          {
            char * pont;            // Verifica se mensagem vazia
            for (pont=bufRec+3; *pont==' '; pont++);
            if (*pont==0)
                break;
            if (Passo==1)
            {
                EnvInicio();
                Passo=2;
            }
          // Processar mensagem
 //printf("[%s]\n", bufRec+3); fflush(stdout);
            if (*pont==0)
                break;
            if (ProcMens(pont))
                return;
          }
// Mensagem no solicitada (provavelmente nunca chegar aqui)
        default:
            delete this;
            return;
        }
    }
}

//------------------------------------------------------------------------------
// Evento do relgio
void TUsuario::rEvento()
{
    switch (Passo)
    {
    case 0:    // Apaga objeto (no recebeu nada do cliente)
      {
        const char mens[]="-Tempo esgotado\x0D\x0A";
        if (Proto==0)
            cEnvia(mens, strlen(mens));
        delete this;
        break;
      }
    case 1:    // Avisa nova conexo telnet/papovox
        EnvInicio();
        Passo=2;
        break;
    case 2:            // No bate-papo: pede o apelido
        EnvMens("Digite seu apelido");
        rTempo(TEMPO_ENTRANDO);
        break;
    case 3:            // No bate-papo: envia mensagem vazia para
        EnvMens("");   // a conexo no ficar "pendurada" se o usurio "cair"
        rTempo(TEMPO_VAZIO);
        cMudaNivel(4,4);
        break;
    default:    // Passo desconhecido: apaga objeto
        delete this;
    }
}

//------------------------------------------------------------------------------
// Recebeu mensagem
bool TUsuario::ProcMens(char * texto)
{
    if (comparaZ(texto,"/sair")==0 || comparaZ(texto,"/quit")==0)
    {
        if (Passo!=3)
            return false;
        char m[100];
        mprintf(m, sizeof(m), "//%s saiu", Nome);
        EnvTodos(m);
        return false;
    }
    if (Passo<3)
    {
        if (verifNome(texto)!=2)
        {
            EnvMens("Apelido invlido, digite outro");
            return true;
        }
        copiastr(Nome, texto, sizeof(Nome));
        Passo=3;
        char m[100];
        mprintf(m, sizeof(m), "//%s chegou", Nome);
        EnvTodos(m);
	EnvMens("Tecle /ajuda para saber os comandos");
        rTempo(TEMPO_VAZIO);
        return true;
    }
    if (comparaZ(texto,"/terminar")==0)
    {
        EnvTodos("/Encerrando ServMud");
        Terminar(EXIT_SUCCESS);
    }
    if (comparaZ(texto,"/ajuda")==0)
    {
        EnvMens("Ajuda:");
        EnvMens("/sair ou /quit - Sai do ServMud");
        EnvMens("/terminar - Encerra o programa");
        EnvMens("/mud endereo porta - Conecta a um mud");
        EnvMens("/mud - Desconecta do mud");
        EnvMens("/con endereo IP - permite uma conexo do endereo IP espeficidado");
        EnvMens("    Nota: ao permitir um endereo deixar de permitir outro");
        EnvMens("/quem - Diz quem est no ServMud");
        EnvMens("/nome apelido - Muda de apelido");
        EnvMens("/c1 - Telnet alterna entre voltar e no voltar as ltimas mensagens quando");
        EnvMens("    tecla ENTER. Papovox alterna entre 80 e 240 caracteres por linha");
        EnvMens("/c2 - Alterna entre filtrar/no filtrar cores; no recomandado para Papovox");
        EnvMens("/ - Envia mensagem vazia para o MUD (pressionar ENTER no MUD)");
        EnvMens("/c - Envia CONTROL+C para o MUD");
        EnvMens("/ seguido de uma mensagem - Envia mensagem para "
                 "quem estiver no ServMud");
        EnvMens("Qualquer outra coisa envia o que escreveu para o MUD");
        EnvMens("Mensagens para o mud que comecem com / escreva // no lugar de /");
        EnvMens("Fim da ajuda");
        return true;
    }
    if (comparaZ(texto, "/c")==0)
    {
        char ch=3;
        if (ClienteMud)
            ClienteMud->cEnvia(&ch, 1);
        return true;
    }
    if (compara(texto, "/nome")==0)
    {
        char * p;
        for (p=texto; *p && *p!=' '; p++);
        for (; *p==' '; p++);
        if (verifNome(p)!=2)
        {
            EnvMens("/Apelido invlido");
            return true;
        }
        Passo=3;
        char m[100];
        mprintf(m, sizeof(m), "//Usurio %s  conhecido como %s", Nome, p);
        copiastr(Nome, p, sizeof(Nome));
        EnvTodos(m);
        return true;
    }
    if (comparaZ(texto, "/quem")==0)
    {
        EnvMens("/Usurios");
        for (TUsuario * u=Primeiro; u; u=u->Depois)
            EnvMens(u->Nome);
        return true;
    }
    if (comparaZ(texto, "/c1")==0)
    {
        Opcoes^=2;
        if (Proto==1)
            EnvMens(Opcoes&2 ? "/c1 No voltando ltimas mensagens"
                             : "/c1 Voltando ltimas mensagens");
        else
            EnvMens(Opcoes&2 ? "/c1 Cortando texto em 240 colunas"
                             : "/c1 Cortando texto em 80 colunas");
        return true;
    }
    if (comparaZ(texto, "/c2")==0)
    {
        Opcoes^=1;
        EnvMens(Opcoes&1 ? "/c2 No filtrando cores"
                         : "/c2 Filtrando cores");
        return true;
    }
    if (compara(texto, "/con")==0)
    {
        const char * p;
        for (p=texto+4; *p==' '; p++);
#ifdef __WIN32__
        con2.s_addr = inet_addr(p);
        con1 = (con2.s_addr!=0 && con2.s_addr!=0xFFFFFFFFLL);
#else
        con1 = inet_aton(p, &con2);
#endif
        if (con1)
        {
            char mens[100];
            mprintf(mens, sizeof(mens), "/con: Aceitando uma conexo de %s",
                        inet_ntoa(con2));
            EnvTodos(mens);
        }
        else
            EnvTodos("/con: s aceitando conexes locais");
        return true;
    }
    if (compara(texto, "/mud")==0)
    {
        char mens[300];
        char * p;
        int  porta;
        int  conManip;
        struct sockaddr_in conSock;
        struct hostent *hnome;

        for (texto+=4; *texto==' '; texto++);
        for (p=texto; *p && *p!=' '; p++);
        if (*p)
        {
            *p++=0;
            for (; *p==' '; p++);
        }
        if (*texto && *p==0)
        {
            strcpy(arqext, ".cfg");
            FILE * arq=fopen(arqnome, "r");
            if (arq==0)
            {
                mprintf(mens, sizeof(mens),
                        "/No consegui abrir arquivo %s", arqnome);
                EnvMens(mens);
                return true;
            }
            int  atual,lido;
            char variavel[0x100];
            char valor[0x100];
            char linhamud[0x100];
            atual=0,*variavel=0,*valor=0,*linhamud=0;
            while (true)
            {
                lido=fread(mens, 1, sizeof(mens), arq);
                if (lido<(int)sizeof(mens))
                    mens[lido++]=10;
                for (int cont=0; cont<lido; cont++)
                {
                    if (mens[cont]==13 || mens[cont]==10)
                    {
                        if (atual>0x100)
                        {
                            for (; atual>0x100; atual--)
                                if (valor[atual-0x101]!=' ')
                                    break;
                            valor[atual-0x100]=0;
                            //printf("[%s] = [%s]\n", variavel, valor);
                            if (comparaZ(variavel, texto)==0)
                                copiastr(linhamud, valor);
                        }
                        atual=0;
                        continue;
                    }
                    if ((atual==0 || atual==0x100) && mens[cont]==' ')
                        continue;
                    if ((unsigned char)mens[cont]<' ')
                        continue;
                    if (atual<=0xFF)
                    {
                        if (mens[cont]=='=')
                        {
                            for (; atual>0; atual--)
                                if (variavel[atual-1]!=' ')
                                    break;
                            variavel[atual]=0;
                            atual=0x100;
                        }
                        else if (atual<0xFF)
                            variavel[atual++]=mens[cont];
                        continue;
                    }
                    if (atual<0x1FF)
                    {
                        valor[atual-0x100]=mens[cont];
                        atual++;
                    }
                }
                if (lido!=sizeof(mens))
                    break;
            }
            fclose(arq);
            if (*linhamud==0)
            {
                EnvMens("/MUD no encontrado");
                return true;
            }
            texto=linhamud;
            for (; *texto==' '; texto++);
            for (p=texto; *p && *p!=' '; p++);
            if (*p)
            {
                *p++=0;
                for (; *p==' '; p++);
            }
        }
        if (*p==0)
        {
            if (ClienteMud==0)
                EnvMens("/No est conectado em um MUD");
            else
            {
                delete ClienteMud;
                ClienteMud=0;
                EnvTodos("/Desconectado do MUD");
            }
            return true;
        }
        porta=atoi(p);
        if (porta<=0 || porta>65535)
        {
            EnvMens("/Porta deve ser um nmero de 1 a 65535");
            return true;
        }
        mprintf(mens, sizeof(mens), "/Conectando em %s %d", texto, porta);
        EnvTodos(mens);

// Conecta ao servidor
#ifdef __WIN32__
        memset(&conSock,0,sizeof(conSock));
        conSock.sin_addr.s_addr=inet_addr(texto);
        if ( conSock.sin_addr.s_addr == INADDR_NONE )
        {
            if ( (hnome=gethostbyname(texto)) == NULL )
            {
                EnvTodos("/Endereo no encontrado");
                return true;
            }
            conSock.sin_addr = (*(struct in_addr *)hnome->h_addr);
        }
        conSock.sin_family=AF_INET;
        conSock.sin_port=htons( (u_short)porta );
        if ( (conManip = socket(PF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
        {
            EnvTodos("/Erro interno");
            return true;
        }
        if ( connect(conManip, (struct sockaddr *)&conSock,
                                      sizeof(struct sockaddr)) == SOCKET_ERROR)
        {
            char x[100];
            mprintf(x, sizeof(x), "/Erro: %s", strerror(errno));
            EnvTodos(x);
            closesocket(conManip);
            return true;
        }
        unsigned long argp=1; // 0=bloquear  1=nao bloquear
        if ( ioctlsocket(conManip, FIONBIO, &argp) !=0 )
            Terminar(EXIT_FAILURE);
#else
        memset(&conSock.sin_zero, 0, 8);
        conSock.sin_family=AF_INET;
        conSock.sin_port=htons(porta);
        conSock.sin_addr.s_addr=inet_addr(texto);
        if ( (conSock.sin_addr.s_addr) == (unsigned long)-1 )
        {
            if ( (hnome=gethostbyname(texto)) == NULL )
            {
                EnvTodos("/Endereo no encontrado");
                return true;
            }
            conSock.sin_addr = (*(struct in_addr *)hnome->h_addr);
        }
        if ( (conManip=socket(PF_INET,SOCK_STREAM,0)) ==-1)
        {
            EnvTodos("/Erro interno");
            return true;
        }
        if ( connect(conManip, (struct sockaddr *)&conSock,
                                          sizeof(struct sockaddr))==-1)
        {
            mprintf(mens, sizeof(mens), "/Erro: %s", strerror(errno));
            EnvTodos(mens);
            close(conManip);
            return true;
        }
        fcntl(conManip, F_SETFL, O_NONBLOCK);
#endif
        if (ClienteMud)
            delete ClienteMud;
        ClienteMud=new TClienteMud;
        ClienteMud->cSockEnv = conManip;
        ClienteMud->cSockRec = conManip;
        EnvTodos("/Conectado");
        return true;
    }
    if (*texto=='/')
        if (texto[1]=='/' || texto[1]==0)
            texto++;
        else
        {
            char x[500];
            for (texto++; *texto==' '; texto++);
            mprintf(x, sizeof(x), "/%s. %s", Nome, texto);
            EnvTodos(x);
            return true;
        }
    if (ClienteMud)
        ClienteMud->EnvMens(texto);
    return true;
}
